<?php
/**
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Pierre Spring <pierre.spring@liip.ch>
 */

// must be run within Dokuwiki
if (!defined('DOKU_INC')) die();

class helper_plugin_dokulatex extends DokuWiki_Plugin 
{

    function getInfo()
    {
        return confToHash(dirname(__FILE__).'/info.txt');
    }

    function getMethods()
    {
        $result = array();
        $result[] = array(
            'name'   => 'html_convert_button',
            'desc'   => 'include a html button',
            'params' => array(),
            'return' => array()
        );
        return $result;
    }

    function html_convert_button($return = false)
    {
        global $conf;
        global $ID;

        $label = $this->getLang('btn_convert');
        if (!$label) {
            // needs translation ;)
            $label = 'Convert into latex';
        }

        $tip = htmlspecialchars($label);

        $ret = '';

        //filter id (without urlencoding)
        $id = idfilter($ID,false);


        //make nice URLs even for buttons
        if($conf['userewrite'] == 2){
            $script = DOKU_BASE.DOKU_SCRIPT.'/'.$id . "?";
        }elseif($conf['userewrite']){
            $script = DOKU_BASE.$id."?";
        }else{
            $script = DOKU_BASE.DOKU_SCRIPT . "?";
            $params['id'] = $id;
        }
        $params['idx'] = ":" . getNS($ID);
        $params['dokulatex'] = 1;

        $ret .= '<form class="button"><div class="no">';
        // $ret .= '<div class="no">';
        $url = $script;

        if(is_array($params)){
            reset($params);
            while (list($key, $val) = each($params)) {
                $url .= $key.'=';
                $url .= htmlspecialchars($val).'&';
            }
        }


        $ret .= '<input id="dokulatex_create_button" type="submit" value="'.htmlspecialchars($label).'" class="button" ';
        $ret .= 'title="'.$tip.'" ';
        // the button will be enabled by js, as it does not
        // make any sense in a browser without js ;)
        $ret .= 'style="display: none;" ';
        // the url attribute will be used by the javascript
        $ret .= 'url="'.$url.'" ';
        $ret .= '/>';
        $ret .= '</div>';
        $ret .= '</form>';

        if ($return) {
            return $ret;
        } else {
            echo $ret;
        }
    }
}
?>
