<?php 
   if(!defined('DOKU_INC')) define('DOKU_INC',realpath(dirname(__FILE__).'/../../../').'/');
   if(!defined('DOKU_PAGES')) define('DOKU_PAGES',DOKU_INC.'data/pages/');
   class Dokulatex 
   { 
      var $unparsed = array (); 
      var $parsed = array (); 
      var $blocks = array(); 
      var $last_loaded; 
      
      function start()
      {
            echo "\documentclass{report}";
            echo "\n";
	          echo "\usepackage{polski}";
	          echo "\n";
	          echo "\usepackage{ulem}";
	          echo "\n";
	          echo "\usepackage{hyperref}";
	          echo "\n";
            echo "\begin{document}";
            echo "\n";
      }
      
      function finish()
      {
		        echo "\end{document}";
      }
      function load($plik) 
      { 
         if($plik == $last_loaded) 
         { 
            $this->unparsed[] = end($this->unparsed); 
         } 
         elseif(file_exists(DOKU_PAGES.$plik.'.txt')) 
         { 
            $file = @fopen(DOKU_PAGES.$plik.'.txt',r); 
            flock($file, 2); 
            $this -> unparsed[] = fread($file,filesize(DOKU_PAGES.$plik.'.txt')); 
            flock($file, 3); 
            $this->last_loaded = $plik; 
         } 
         else 
            echo 'Plik ' .$plik. ' nie istnieje.'; 
      } #end function load() 
      
      function convert($plik) 
      { 
         $i=0; 
         foreach ($this->unparsed as $page) 
         { 
            $found = array();
        if(preg_match_all("#\\\(.[^backslash])#is", $page, $found)) //backslash
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '\\'.$block; 
                  $block_values = '$\backslash$'.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
         if(preg_match_all("#[^h]\\$(.[^b][^\$])#is", $page, $found)) //dolar
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '$'.$block; 
                  $block_values = '\$'.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
         if(preg_match_all("#{{(.+?)}}#is", $page, $found)) //grafika
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '{{'.$block.'}}'; 
                  $block_values = '\includegraphics@'.$block.'@';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
        if(preg_match_all("#\{(.)#is", $page, $found)) // nawias {
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '{'.$block; 
                  $block_values = ' $\lbrace$'.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
        if(preg_match_all("#\&(.[^&])#is", $page, $found)) //ampersand
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '&'.$block; 
                  $block_values = '\&'.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
         if(preg_match_all("#\%(.[^%])#is", $page, $found)) //procent
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '%'.$block; 
                  $block_values = '\%'.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
         if(preg_match_all("#\^(.)#is", $page, $found)) //karetka
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '^'.$block; 
                  $block_values = '\verb=^='.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
       if(preg_match_all("#\}(.)#is", $page, $found)) //nawias }
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '}'.$block; 
                  $block_values = '$\rbrace$ '.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }     
      if(preg_match_all("#\*\*(.+?)\*\*#is", $page, $found)) //bold
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '**'.$block.'**'; 
                  $block_values = '\textbf{'.$block.'}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
			if(preg_match_all("#[^:]\/\/(.+?)\/\/#is", $page, $found)) //italik
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '//'.$block.'//'; 
                  $block_values = '\textit{'.$block.'}'; 
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
			if(preg_match_all("#\_\_(.+?)\_\_#is", $page, $found)) //podkresl
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '__'.$block.'__'; 
                  $block_values = '\underline{'.$block.'}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
  	if(preg_match_all("#\=\=\=\=\=\=(.+?)\=\=\=\=\=\=#is", $page, $found)) 
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '======'.$block.'======'; 
                  $block_values = '\section{'.$block.'}\label{'.$block.'}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
  	if(preg_match_all("#\=\=\=\=\=(.+?)\=\=\=\=\=#is", $page, $found)) 
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '====='.$block.'====='; 
                  $block_values = '\subsection{'.$block.'}\label{'.$block.'}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
  	if(preg_match_all("#\=\=\=\=(.+?)\=\=\=\=#is", $page, $found)) 
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '===='.$block.'===='; 
                  $block_values = '\subsubsection{'.$block.'}\label{'.$block.'}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
    if(preg_match_all("#\=\=\=(.+?)\=\=\=#is", $page, $found)) 
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '==='.$block.'==='; 
                  $block_values = '\paragraph{'.$block.'}\label{'.$block.'}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
  if(preg_match_all("#\=\=(.+?)\=\=#is", $page, $found)) 
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '=='.$block.'=='; 
                  $block_values = '\subparagraph{'.$block.'}\label{'.$block.'}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
  if(preg_match_all("#\'\'(.+?)\'\'#is", $page, $found)) //verb
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '\'\''.$block.'\'\''; 
                  $block_values = '\verb='.$block.'=';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
  if(preg_match_all("#<del>(.+?)<\/del>#is", $page, $found)) //skresl
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '<del>'.$block.'</del>'; 
                  $block_values = '\sout{'.$block.'}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
  if(preg_match_all("#<sub>(.+?)<\/sub>#is", $page, $found)) //subscript
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '<sub>'.$block.'</sub>'; 
                  $block_values = '$_{'.$block.'}$';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
  if(preg_match_all("#<sup>(.+?)<\/sup>#is", $page, $found)) //superscript
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '<sup>'.$block.'</sup>'; 
                  $block_values = '$^{'.$block.'}$';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
  if(preg_match_all("#<(.+)>#is", $page, $found)) //
            { 
               foreach($found[1] as $block) 
               { 
                 $block_name = '<'.$block.'>'; 
                  $block_values = $block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
    if(preg_match_all("#\s\s[^*][^-](.+[\n])\n#is", $page, $found)) //verbatim
            { 
               foreach($found[1] as $block) 
               { 
                 $block_name = '  '.$block; 
                  $block_values = '\verb'.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
  if(preg_match_all("#\(\((.+)\)\)#is", $page, $found)) //footnote
            { 
               foreach($found[1] as $block) 
               { 
                 $block_name = '(('.$block.'))'; 
                  $block_values = '\footnote{'.$block.'}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
    if(preg_match_all("#\s\s\*(.+?[^\n])\n#is", $page, $found)) //item
            { 
               foreach($found[1] as $block) 
               { 
                 $block_name = '  *'.$block; 
                  $block_values = '\item'.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
    if(preg_match_all("#\s\s\s\s\*(.+?[^\n])\n#is", $page, $found)) //item
            { 
               foreach($found[1] as $block) 
               { 
                 $block_name = '    *'.$block; 
                  $block_values = '\item'.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
    if(preg_match_all("#\s\s\s\s\s\s\*(.+?[^\n])\n#is", $page, $found)) //item
            { 
               foreach($found[1] as $block) 
               { 
                 $block_name = '      *'.$block; 
                  $block_values = '\item'.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
     if(preg_match_all("#[^}\n]\item(.+)\n\n#is", $page, $found)) //itemize
            { 
               foreach($found[1] as $block) 
               { 
                 $block_name = '\item'.$block; 
                  $block_values = '\begin{itemize} \item'.$block.'\end{itemize}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
      if(preg_match_all("#\s\s-(.+?[^\n])\n#is", $page, $found)) //enum
            { 
               foreach($found[1] as $block) 
               { 
                 $block_name = '  -'.$block; 
                  $block_values = '\item'.$block.' ';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
        if(preg_match_all("#\s\s\s\s-(.+?[^\n])\n#is", $page, $found)) //enum
            { 
               foreach($found[1] as $block) 
               { 
                 $block_name = '    -'.$block; 
                  $block_values = '\item'.$block.' ';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
          if(preg_match_all("#\s\s\s\s\s\s-(.+?[^\n])\n#is", $page, $found)) //enum
            { 
               foreach($found[1] as $block) 
               { 
                 $block_name = '      -'.$block; 
                  $block_values = '\item'.$block.' ';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
     if(preg_match_all("#[^}\n]\item(.+)\s\n\n#is", $page, $found)) //enumerate
            { 
               foreach($found[1] as $block) 
               { 
                 $block_name = '\item'.$block.' '; 
                  $block_values = '\begin{enumerate} \item'.$block.' \end{enumerate}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
   if(preg_match_all("#\[\[http:\/\/(.+?)\]\]#is", $page, $found)) //ref
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '[[http://'.$block.']]'; 
                  $block_values = '\url{http://'.$block.'}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }  
  if(preg_match_all("#\[\[(.+?)\]\]#is", $page, $found)) //ref
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '[['.$block.']]'; 
                  $block_values = $block.' \ref{'.$block.'}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }  
  if(preg_match_all("#gjn-t1\#(.+?)}#is", $page, $found)) 
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = 'gjn-t1#'.$block.'}'; 
                  $block_values = $block.'}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
  if(preg_match_all("#\#(.+?)}#is", $page, $found)) 
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '#'.$block.'}'; 
                  $block_values = $block.'}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
              if(preg_match_all("#[^$]_(.[^_])#is", $page, $found)) //podkreslenie
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '_'.$block; 
                  $block_values = '\_'.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
             if(preg_match_all("#\~(.[^~])#is", $page, $found)) //tylda
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '~'.$block; 
                  $block_values = '$\sim$'.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
            if(preg_match_all("#\#(.)#is", $page, $found)) //hasz
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '#'.$block; 
                  $block_values = '\# '.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
            if(preg_match_all("#\\\item{\s(.+?)\s}#is", $page, $found)) //item
            { 
               foreach($found[1] as $block) 
               { 
                 $block_name = '\item'.$block.'}'; 
                  $block_values = '\item'.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            }
         if(preg_match_all("#\includegraphics@(.+?)@#is", $page, $found)) //grafika
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '\includegraphics@'.$block.'@'; 
                  $block_values = '\begin{figure} \includegraphics{'.$block.'}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
          if(preg_match_all("#\|(.+?)\}#is", $page, $found)) //grafika
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '|'.$block.'}'; 
                  $block_values = '} \caption{'.$block.'} \end{figure}';
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
            if(preg_match_all("#{\s(.+?)#is", $page, $found)) // ladzenie1
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = '{ '.$block; 
                  $block_values = '{'.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
            if(preg_match_all("#\s}(.+?)#is", $page, $found)) // ladzenie2
            { 
               foreach($found[1] as $block) 
               { 
                  $block_name = ' }'.$block; 
                  $block_values = '}'.$block;
                  $page = str_replace($block_name, $block_values, $page); 
               } 
            } 
                    
            $this -> parsed[] = $page; 
            $i++; 
         } 
      } #end function parse() 
      
      function show_result($which="all",$to=0) 
      { 
         if($which >= 0 && $to >= 0 && $to <= count($this->parsed) && $which != 'all') 
         { 
            if($which < $to) 
            { 
               while($which <= $to) 
               { 
                  echo $this->parsed[$which]; 
                  $which++; 
               } 
            } 
            else 
            { 
               while($which >= $to) 
               { 
                  echo $this->parsed[$which]; 
                  $which--; 
               } 
            } 
         } 
         elseif($which != 'all') 
         { 
            echo $this->parsed[2]; 
         } 
         else 
         { 
            foreach($this->parsed as $parsed) 
            { 
               echo $parsed; 
            } 
         } 
      } #end function show_result() 
   } #end class pages 
?>